#%%
import os
import sys
# change path later based on location of Results folder
sys.path.append('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration')
path1=sys.path[-1]
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
from Analysis.Results import common_functions as cf
from Analysis.Results.Result_1 import reading_n_processing as rnp
from Analysis.Results.Result_1 import Buoy_Direct_TA as bdt
from Analysis.Results.Result_1 import Model_Buoy_TA as mbt
import xarray as xr
import importlib
importlib.reload(cf)

folder='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Buoy_data_excel/procesd_buoy_loc_data_Lars/'
Bnum='03'
dt=15 #mins
sampling_period=dt/60 #hours
TC=cf.Tidal_const()
TC_value=np.fromiter(TC.values(),dtype=float)
TCname=TCname=np.array(list(TC.keys()))
(Xib,Yib,Uibt,Vibt,Tib)=rnp.get_buoy_tidal_data(folder,Bnum)
model_param_file='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_'+Bnum+'_opt.csv'
mod_data=pd.read_csv(model_param_file)
opt_param_u=mod_data['Value_AP'].values[0:2*len(TCname)]
opt_param_v=mod_data['Value_AP'].values[2*len(TCname):4*len(TCname)]
model_file='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Calibration/Lars_Data/GTSM_TA_grid_May.nc'
mod_thc_data=xr.open_dataset(model_file)
#%%
comp='U'

M=mbt.compute_M_matrix(Xib,Yib,Tib,model_file,comp)
Tib=Tib.values
#%%
#save the M matrix in a file
ds=xr.Dataset({'M':(("Time","Param"),M)},coords={'Time':Tib,'Param':np.arange(2*len(TCname))})
# ds.attrs['Description']='Model matrix for buoy velocities '+Bnum
# ds.to_netcdf('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_'+Bnum+'_M_'+comp+'.nc')